#
# Daikon variable trace flattening module.
#
# Copyright (C) 2008-2011 Antonio García-Domínguez
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
# USA

package FlattenTraces;

use strict;
use warnings;
use Exporter "import";
our @EXPORT_OK = qw(printFlattenedTraces flattenDTrace computeByIndexFlattening computeByNodeSetFlattening);

use Daikon qw(cargarDTrace cargarDecls imprimirDTrace
	      C_VALUE C_MOD C_TJAVA C_TXSD C_TDUMMYHASH C_NAME C_VARLIST);

sub printFlattenedTraces {
  my ($indexFlattening, $rutaDecls, $rutaDTrace) = @_;

  my ($rhInfoTipos, $dummy) = cargarDecls($rutaDecls);
  my $rhDTraceOrig  = cargarDTrace($rutaDTrace);
  my $rfFlatten     = defined $indexFlattening
    ? \&computeByIndexFlattening
      : \&computeByNodeSetFlattening;
  my $rhDTraceNuevo = flattenDTrace($rhInfoTipos, $rhDTraceOrig, $rfFlatten);
  imprimirDTrace($rhDTraceNuevo);
}

=head2 flattenDTrace(rhVarsByPP, rvTraces, rfComputeValue)

=over 2

=item Usage:

Public function.

=item Arguments:

=over 2

=item rhVarsByPP:

Reference to a hash with the type information of each variable over
every program point. These variables are the result of flattening the
original declarations, so they won't necessarily match the variables
used in rvTraces.

=item rvTraces:

Reference to a vector of hashes with the traces from every execution
of every program point.

=item rfComputeValue:

Reference to a function which computes the flattened value of each
variable.

=back

=item Description:

Flattens the original traces, by computing the values for the
variables in the flattened declarations using the provided function.

=back

=cut

sub flattenDTrace
{
    my ($rhInfoTipos, $rvDTraceOrig, $rfCalcularValor) = @_;

    my $rvDTraceNuevo = [];

    foreach my $rhPunto (@$rvDTraceOrig) {

	my $nombre = $rhPunto->{C_NAME()};
	my $rhVars = $rhPunto->{C_VARLIST()};

	# Nos saltamos el tipo si tras aplanar no quedaron variables
	next if (scalar (keys %{$rhInfoTipos->{$nombre}}) == 0);

	# Construimos la nueva entrada tras aplanar
	my $rhVarsAplanadas = {};
	my $rhPuntoAplanado = {C_NAME() => $nombre,
			       C_VARLIST() => $rhVarsAplanadas};

	foreach my $expr (keys %{$rhInfoTipos->{$nombre}}) {
	    # No hay necesidad de calcular el valor si está prefijado
	    # (al estilo de 'int = 0')
	    next if index($rhInfoTipos->{$nombre}->{$expr}->{C_TJAVA()},"=") != -1;

	    # Calculamos el valor para la variable aplanada
	    my $valor = &$rfCalcularValor($expr, $rhVars, $rhInfoTipos->{$nombre});
	    $rhVarsAplanadas->{$expr} = $valor;
	}

	push @$rvDTraceNuevo, $rhPuntoAplanado;
    }

    return $rvDTraceNuevo;
}

=head2 computeByIndexFlattening(var, rhTraces, rhVarsByPP)

=over 2

=item Usage:

Public function.

=item Arguments:

=over 2

=item expr:

Name of the Daikon variable whose value we need to compute.

=item rhTraces:

Reference to a hash with the name of the program point and the traced
values for all its variables.

=item rhVarsByPP:

Reference to a hash with the type information of each variable in
every program point. It should have been produced by applying index
flattening to the original declarations generated by takuan-java.

=back

=item Description:

Computes the value of expr, by using the provided traces and type
information.

=back

=cut

sub computeByIndexFlattening
{
    my ($expr, $rhTrazas, $rhTiposPunto) = @_;

    # Existe la posibilidad de que sea un nonsensical: buscamos
    # aquellas expresiones que sean prefijo de la actual y sean
    # nonsensical.
    my @vPrefijosNonsensical = grep {
	index($expr, "${_}.") == 0 && $rhTrazas->{$_}->{C_VALUE()} eq "nonsensical";
    } (keys(%$rhTrazas));

    if (scalar @vPrefijosNonsensical != 0) {
	return createNonsensical();
    }    
    elsif (exists $rhTrazas->{$expr}) {
	# Escalar
	return $rhTrazas->{$expr};
    }
    elsif ($expr =~ /\[\]$/) {
	# Vector: hay que recoger sus elementos de entre las expresiones
	my $prefijo = substr $expr, 0, $-[0];

	my @valores = ();
	my $i       = 1;
	my $mod     = 1;
	while (exists $rhTrazas->{"$prefijo\[$i\]"}) {
	    push @valores, $rhTrazas->{"$prefijo\[$i\]"}->{C_VALUE()};
	    $mod = ($mod != 2 ? $rhTrazas->{"$prefijo\[$i\]"}->{C_MOD()} : $mod);
	    $i++;
	}

	return {
	    C_VALUE() => "[" . (join " ", @valores) . "]",
	    C_MOD() => $mod,
	};
    }
    elsif ($expr =~ m#@[^/]+$#) {
	# Atributo opcional sin valor: marcar como nonsensical
	return createNonsensical();
    }
    elsif (exists $rhTiposPunto->{$expr} && $rhTiposPunto->{$expr}->{C_TXSD()} eq C_TDUMMYHASH()) {
	# El falso hashcode usado para aplacar a Daikon siempre es
	# nonsensical para evitar que se generen invariantes
	return createNonsensical();
    }
    elsif (scalar(keys(%$rhTrazas)) == 0) {
	# Si la salida esta completamente vacia, se debe a que la actividad falló
	return createNonsensical();
    }
    else {
	die "No se pudo calcular el valor de $expr";
    }
}

=head2 computeByIndexFlattening(var, rhTraces, rhVarsByPP)

=over 2

=item Usage:

Public function.

=item Arguments:

=over 2

=item expr:

Name of the Daikon variable whose value we need to compute.

=item rhTraces:

Reference to a hash with the name of the program point and the traced
values for all its variables.

=item rhVarsByPP:

Reference to a hash with the type information of each variable in
every program point. It should have been produced by applying nodeset
flattening to the original declarations generated by takuan-java.

=back

=item Description:

Computes the value of expr, by using the provided traces and type
information.

=back

=cut

sub computeByNodeSetFlattening
{
    my ($expr, $rhTrazas, $rhTiposPunto) = @_;

    # Existe la posibilidad de que sea un nonsensical: buscamos
    # aquellas expresiones que sean prefijo de la actual y sean
    # nonsensical.
    my @vPrefijosNonsensical = grep {
	index($expr, "${_}.") == 0 && $rhTrazas->{$_}->{C_VALUE()} eq "nonsensical";
    } (keys(%$rhTrazas));

    if (scalar @vPrefijosNonsensical != 0) {
	return createNonsensical();
    }    
    elsif (exists $rhTrazas->{$expr}) {
	# Escalar
	return $rhTrazas->{$expr};
    }
    elsif ($expr =~ /\[\]$/) {
	# Vector: hay que recoger sus elementos de entre las expresiones

	# Generaremos una expresión para filtrar los elementos de este vector
	my $regexpExpr = $expr;
	$regexpExpr    =~ s/(?:\[\])?\./(?:\\[\[0-9\]+\\])?\./g;
	$regexpExpr    =~ s/(?:\[\])?$/(?:\\[\[0-9\]+\\])?/g;
	my @claves     = grep /^$regexpExpr$/, sort keys %$rhTrazas;

	# Usamos una rodaja de hash y extraemos los valores que deseamos
	my @elems      = @$rhTrazas{@claves};
	my @valores    = map {$_->{C_VALUE()}} @elems;
	my $mod        = _max(map {$_->{C_MOD()}} @elems);
	if (!defined($mod)) {
	    # Vector vacío
	    $mod = 0;
	}

	die "Se dice que el valor $expr es nonsensical, y sin embargo tiene valor válido" 
	    if $mod == 2 && scalar @valores > 0;

	return {
	    C_VALUE() => "[" . (join " ", @valores) . "]",
	    C_MOD() => $mod,
	};
    }
    elsif ($expr =~ m#@[^/]+$#) {
	# Atributo opcional sin valor: marcar como nonsensical
	return createNonsensical();
    }
    elsif (exists $rhTiposPunto->{$expr} && $rhTiposPunto->{$expr}->{C_TXSD()} eq C_TDUMMYHASH) {
	# El falso hashcode usado para aplacar a Daikon siempre es
	# nonsensical para evitar que se generen invariantes
	return createNonsensical();
    }
    elsif (scalar(keys(%$rhTrazas)) == 0) {
	# Si la salida esta completamente vacia, se debe a que la actividad fallo
	return createNonsensical();
    }
    else {
	die "No se pudo calcular el valor de $expr";
    }
}

sub createNonsensical {
  return {C_VALUE() => "nonsensical",
	  C_MOD() => 2};
}

sub _max {
    my @elems = @_;
    return undef 
	if (scalar @elems == 0);

    my $max = shift @elems;
    foreach my $val (@elems) {
	$max = $val if $val > $max;
    }

    return $max;
}

1;
